<div id="app" v-cloak>
    <el-card class="box-card control">

        <el-row>
            <el-col :span="3">
                <a>Nginx 控制中心</a>
            </el-col>
            <el-col :span="5">
                <a @click="nginxStart">
                    <el-image v-if="run" :src="'${UrlUtil.getUrl('/static/img/start_.png')}'"
                              style="width: 50px; height: 50px"
                              fit="fill"></el-image>
                    <el-image v-if="!run" :src="'${UrlUtil.getUrl('/static/img/start.png')}'"
                              style="width: 50px; height: 50px"
                              fit="fill"></el-image>
                </a>
                <a @click="nginxStop">
                    <el-image v-if="run" :src="'${UrlUtil.getUrl('/static/img/stop.png')}'"
                              style="width: 50px; height: 50px"
                              fit="fill"></el-image>
                    <el-image v-if="!run" :src="'${UrlUtil.getUrl('/static/img/stop_.png')}'"
                              style="width: 50px; height: 50px"
                              fit="fill"></el-image>
                </a>
                <a @click="nginxReload">
                    <el-image v-if="run" :src="'${UrlUtil.getUrl('/static/img/reload.png')}'"
                              style="width: 50px; height: 50px"
                              fit="fill"></el-image>
                    <el-image v-if="!run" :src="'${UrlUtil.getUrl('/static/img/reload_.png')}'"
                              style="width: 50px; height: 50px"
                              fit="fill"></el-image>
                </a>
            </el-col>
        </el-row>
    </el-card>

    <el-card class="box-card">
        <el-form class="search" :inline="true" :model="vm" ref="vm" label-position="right" label-width="90px">
            <el-form-item label="名称" prop="name">
                <el-input v-model="vm.name" clearable size="mini" placeholder="请输入名称"></el-input>
            </el-form-item>
            <el-form-item label="路径" prop="path">
                <el-input v-model="vm.path" clearable size="mini" placeholder="请输入路径"></el-input>
            </el-form-item>
            <el-form-item label="代理地址" prop="location">
                <el-input v-model="vm.location" clearable size="mini" placeholder="请输入代理地址"></el-input>
            </el-form-item>
            <el-form-item>
                <el-button type="primary" size="mini" icon="el-icon-search" @click="onSearch">搜索</el-button>
                <el-button type="warning" size="mini" icon="el-icon-refresh-left" @click="onReset('vm')">重置</el-button>
            </el-form-item>
        </el-form>
    </el-card>

    <el-card class="box-card">
        <el-row>
            <el-col :span="12">
                <el-button type="success" size="mini" icon="el-icon-plus" @click="onCreate">新增</el-button>

                <el-button type="warning" size="mini" icon="el-icon-download" @click="onExport">导出</el-button>
            </el-col>

            <el-col :span="12">
                <el-button-group style="float: right;">
                    <el-tooltip effect="dark" content="Excel模板下载" placement="bottom">
                        <el-button size="mini" icon="el-icon-date" @click="onTemplate"></el-button>
                    </el-tooltip>

                    <el-tooltip effect="dark" content="Excel导入" placement="bottom">
                        <el-button size="mini" icon="el-icon-upload2" @click="onImport"></el-button>
                    </el-tooltip>

                    <el-tooltip effect="dark" content="批量删除" placement="bottom">
                        <el-button size="mini" icon="el-icon-delete" @click="onBitchDelete"></el-button>
                    </el-tooltip>

                    <el-tooltip effect="dark" content="刷新" placement="bottom">
                        <el-button size="mini" icon="el-icon-refresh" @click="onFind"></el-button>
                    </el-tooltip>
                </el-button-group>
            </el-col>
        </el-row>

        <el-table
                class="data"
                @selection-change="onSelectionChange"
                empty-text="无数据"
                :data="result"
                size="mini">
            <el-table-column
                    align="center"
                    type="selection"
                    width="45">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="name"
                    label="名称"
                    width="80">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="port"
                    label="端口"
                    width="80">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="path"
                    label="路径"
                    width="100">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="type"
                    label="类型"
                    width="80">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="location"
                    width="250"
                    label="代理地址">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="note"
                    label="备注"
                    width="100">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="createTime"
                    width="140"
                    label="创建时间">
            </el-table-column>
            <el-table-column
                    align="center"
                    fixed="right"
                    width="120"
                    label="操作">
                <template slot-scope="scope">
                    <wb-dropdown :arg="scope.row">
                        <wb-dropdown-item value="编辑" icon="el-icon-edit" @click="onEdit"></wb-dropdown-item>
                        <wb-dropdown-item value="删除" icon="el-icon-delete" @click="onDelete"></wb-dropdown-item>
                    </wb-dropdown>
                </template>
            </el-table-column>
        </el-table>

        <el-pagination
                background
                v-if="vm.totalCount > vm.pageSize"
                style="margin-top: 10px"
                @current-change="onPageChange"
                :current-page="vm.pageNumber"
                :page-size="vm.pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="vm.totalCount">
        </el-pagination>
    </el-card>


    <el-dialog :title="form.title" :visible.sync="form.dialog" width="550px">
        <el-form :model="form" :rules="formRules" ref="form" label-width="80px"
                 style="width: 400px;margin: 0 auto">
            <el-form-item label="映射名称" prop="name">
                <el-row>
                    <el-col :span="22">
                        <el-input v-model="form.name" clearable size="small" placeholder="映射名称"></el-input>
                    </el-col>
                </el-row>
            </el-form-item>
            <el-form-item label="端口路径" prop="context">
                <el-row>
                    <el-col :span="8">
                        <el-input v-model="form.port" type="number" clearable size="small"
                                  placeholder="映射端口"></el-input>
                    </el-col>
                    <el-col :span="1">
                        ：
                    </el-col>
                    <el-col :span="13">
                        <el-input v-model="form.path" clearable size="small" placeholder="字母数字组合">
                        </el-input>
                    </el-col>
                </el-row>
            </el-form-item>
            <el-form-item label="映射类型" prop="type">
                <el-radio v-model="form.type" label="HTTP">HTTP</el-radio>
                <el-radio v-model="form.type" label="FILE">FILE</el-radio>
                <el-radio v-model="form.type" label="转HTTPS">转HTTPS</el-radio>
            </el-form-item>
            <el-form-item label="映射地址" prop="location">
                <el-row>
                    <el-col :span="22">
                        <el-input v-if="form.type=='HTTP'" v-model="form.location" clearable size="small"
                                  placeholder="代理地址http://"></el-input>
                        <el-input v-if="form.type=='FILE'" v-model="form.location" clearable size="small"
                                  placeholder="文件地址D:\ or /root"></el-input>
                    </el-col>
                    <el-col :span="2" style="text-align: right">
                        <el-popover
                                placement="top-start"
                                width="200"
                                trigger="hover"
                                content="映射类型为文件时，映射路径名需和即将映射的文件夹一样，且不以“\”结尾，映射地址为该文件夹的上一层，则可正常访问。">
                            <i slot="reference" class="el-icon-warning-outline"></i>
                        </el-popover>
                    </el-col>
                </el-row>
            </el-form-item>
            <el-form-item label="映射备注" prop="note">
                <el-row>
                    <el-col :span="22">
                        <el-input type="textarea" :autosize="{ minRows: 3, maxRows: 5}" v-model="form.note" clearable
                                  size="small"
                                  placeholder="备注信息"></el-input>
                    </el-col>
                </el-row>
            </el-form-item>
        </el-form>
        <span slot="footer" class="dialog-footer">
            <el-button size="small" @click="form.dialog = false">取 消</el-button>
            <el-button size="small" type="primary" @click="onSave">保存</el-button>
        </span>
    </el-dialog>
</div>
<style>
    #app {
        padding: 10px;
        margin: 0 auto;
        width: 1080px;
    }

    .box-card {
        margin: 10px;
    }

    .control a:first-child {
        padding-right: 10px;
    }

    .control a {
        display: inline-block;
        line-height: 50px;
        height: 50px;
        vertical-align: top;
    }

    .control a:hover {
        background: #e7e7e7;
    }

    .control a:first-child:hover {
        background: #ffffff;
    }
</style>
<script>
    var app = new Vue({
        mixins: [mixin],
        el: "#app",
        data: {
            module: 'conf',
            target: 'mapping',
            vm: {//条件及分页参数
                name: "",
                port: "",
                path: "",
                type: "",
                location: "",
                pageNumber: 1,
                pageSize: 10,
                totalCount: 0,
                sortKey:'CREATE_TIME',
                sortType:'DESC'
            },
            form: {//待提交表单
                title: "",
                dialog: false,
                id: '',
                name: "",
                port: "",
                path: "",
                type: "",
                location: "",
                note: "",
                rowVersion: ""
            },
            formRules: {
                name: [
                    {required: true, message: '名称不能为空', trigger: 'blur'},
                    {min: 1, max: 50, message: '名称长度在 1 到 50 个字符', trigger: 'blur'}
                ],
                port: [
                    {required: true, message: '端口不能为空', trigger: 'blur'},
                    {pattern: "^[0-9]*$", message: '映射端口只能为数字', trigger: 'blur'},
                ],
                path: [
                    {required: true, message: '路径不能为空', trigger: 'blur'},
                    {pattern: "/|([a-zA-Z][a-zA-Z0-9_]*/)", message: '上下文须是(/)开始结果，中间为字母、数字、_等组合', trigger: 'blur'},
                ],
                type: [
                    {required: true, message: '类型不能为空', trigger: 'blur'},
                    {min: 1, max: 50, message: '类型长度在 1 到 50 个字符', trigger: 'blur'}
                ],
                location: [
                    {required: true, message: '代理地址不能为空', trigger: 'blur'},
                    {
                        validator: function (rule, value, callback) {
                            if (app.form.type == "HTTP") {
                                if (value.match("http:\/\/.*")) {
                                    callback();
                                } else {
                                    callback(new Error("需以http://协议开始"))
                                }
                            }
                            if (app.form.type == "FILE") {
                                if (value.match("^[A-Z]:\\\\.*$|^[A-Z]:/.*$|^/.*$")) {
                                    callback();
                                } else {
                                    callback(new Error("windows目录(C:\\)或linux目录(\\)"))
                                }
                            }
                        }, trigger: 'blur'
                    }
                ]
            },
            run: ${run?default('false')}
        },
        methods: {
            onCreate: function () {
                this.form.title = "映射新增";
                this.form.dialog = true;
                this.form.id = "";
                this.form.name = "";
                this.form.port = ${serverPort?default("80")};
                this.form.path = "";
                this.form.type = "HTTP";
                this.form.location = "";
                this.form.note = "";
            },
            onEdit: function (item) {
                this.form.title = "映射编辑";
                this.form.dialog = true;
                this.form.id = item.id;
                this.form.name = item.name;
                this.form.port = item.port;
                this.form.path = item.path;
                this.form.type = item.type;
                this.form.location = item.location;
                this.form.note = item.note;
                this.form.rowVersion = item.rowVersion;
            },
            onDelete: function (item) {
                this.$confirm('将删除该项, 是否继续?', '提示', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: 'warning'
                }).then(function () {
                    new Ajax()
                            .module(this.module)
                            .target(this.target)
                            .data({id: item.id})
                            .delete(function (response) {
                                if (response.errors.length > 0) {
                                    nav.e(response.errors[0].message);
                                } else {
                                    nav.s("删除成功");
                                    this.onFind();
                                }
                            }.bind(this))
                }.bind(this)).catch(function (action) {

                });
            },
            startMonitor: function () {
                if (window.EventSource) {
                    window.evtSource = new EventSource('${UrlUtil.getUrl("/sse/1")}');
                    window.evtSource.addEventListener('message', function (e) {

                        var msg = JSON.parse(e.data);
                        if (msg.type == 'NGINX_STATE') {//状态推送
                            if (this.run != msg.object.run) {

                                this.$notify.info({
                                    title: '提示',
                                    message: "Nginx 运行状态发生变化。",
                                    duration: 5000
                                });
                                this.run = msg.object.run;
                            }
                        }
                    }.bind(this))
                }
            },
            nginxStart: function () {
                new Ajax("conf", "nginx", "start").post(function (response) {
                    if (response.errors.length > 0) {
                        nav.e(response.errors[0].message);
                    } else {
                        this.onFind();
                        this.form.dialog = false;
                    }
                }.bind(this))
            },
            nginxStop: function () {
                new Ajax("conf", "nginx", "stop").post(function (response) {
                    if (response.errors.length > 0) {
                        nav.e(response.errors[0].message);
                    } else {
                        this.onFind();
                        this.form.dialog = false;
                    }
                }.bind(this))
            },
            configFlush: function () {
                ajax.configFlush();
            },
            onRefresh: function () {
                this.configFlush();
                this.onFind();
            },
            nginxReload: function () {
                new Ajax("conf", "nginx", "reload").post(function (response) {
                    if (response.errors.length > 0) {
                        nav.e(response.errors[0].message);
                    } else {

                    }
                }.bind(this))
            }
        },
        mounted: function () {
            this.onFind();
            this.startMonitor();
        },
    })
</script>
